//+------------------------------------------------------------------+
//|                                                           Goldix |
//|                                         Copyright 2016, ForexCue |
//+------------------------------------------------------------------+
#property version "1.0"
#property copyright "Copyright  2016, ForexCue.com"
#property description "EA trades Gold Euro XAUEUR."
#property description "Goldix 1.0"
#property strict
//+--------------------------

//Trades XAUEUR Forexcue.com

// Note to coders. 
// This code is supplied free of charge and please 
// if you make some optimisation that is worth mentioning, 
// go to MQL5.com to share.


extern string title = "Goldix 1.0 from ForexCue.com"; // Goldix 1.0 from ForexCue.com
 
extern double
   LSize = 0, // Lot Size, 0 = Autolot
   Risk = 1,    //Lot Risk % (Autolot)
   Tp = 1,         //Take Profit in Euros
   Sl = 100, // Stop Loss in Euros
   Msl = 2, //Trailing Stop Loss in Euros
   Step = 2, //Trailing Stop Steps in Euros
   Hedge = 1, // Hedge Distance in Euros
   HedgeF = 3, // Hedge Multiplying Factor
   Marge = 100; // Margin Take Out in Euros Profit
   
int
   ticket=-1,
   oldday=-1,
   ok=0;
   

double
   Lot,test,eqt,bal,tpopen,x,tp,tp1,tp2,
   minspread=100;
   
string
   msg = "";
   
bool
   chk = false;
      
//+------------------------------------------------------------------+
//| OnInit function                                                  |
//+------------------------------------------------------------------+

   
//+------------------------------------------------------------------+
//| OnTick function                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {

// coders could complete to fit all possibility of leverage 
// or replace with an intelligent formula

   tp=AccountLeverage();
   if (tp == 1000){
      tp1=1;
   }
   if (tp == 100){
      tp2=10;
   }
   if (tp == 10){
      tp2=100;
   }
   
   Lot=(AccountEquity()/10000)*(Risk/tp2);
   Lot=Lot * 100;
   Lot=int(Lot);
   Lot=Lot / 100;
      
   if (LSize > 0){
      Lot = LSize;
   }
      
   if ((Day() != oldday) && (ok == 0)){
      ticket=OrderSend(Symbol(),OP_BUY,Lot,Ask,0,Bid-Sl,Ask+Tp,"",0,0,Green);
      tpopen=Ask;
      ok=1;
      oldday=Day();
   }

   if ((Hedge > 0) && (ok == 1)){
      if (Bid < (tpopen - Hedge)){
         ticket=OrderSend(Symbol(),OP_SELL,Lot*HedgeF,Bid,0,Ask+Sl,Bid-Tp,"",0,0,Red);
         ok=2;
      }
   }

   if ((Msl > 0) && (OrdersTotal() > 0)){
      for(int i=0; i<=OrdersTotal(); i++){
         ticket = OrderSelect(i,SELECT_BY_POS);
         
         if (OrderType() == OP_SELL){
            test=OrderStopLoss()-Msl-Step;
            if ((Bid < test) && (Bid < OrderOpenPrice()-Msl-Step)){
               chk=OrderModify(OrderTicket(),OrderOpenPrice(),Bid+Msl,OrderTakeProfit(),0,0);
            }   
         }
         
         if (OrderType() == OP_BUY){
            test=OrderStopLoss()+Msl+Step;
            if ((Ask > test) && (Ask > OrderOpenPrice()+Msl+Step)){
               chk=OrderModify(OrderTicket(),OrderOpenPrice(),Ask-Msl,OrderTakeProfit(),0,0);
            }   
         }
      }
   }
 
   if (Hour() > 22){
      ok=0;

   }
 
 
 if ( (AccountEquity() > (AccountBalance()+Marge)) && (ok == 2) ){
      for (int i=0; i<=OrdersTotal(); i++){
         chk=OrderSelect(i, SELECT_BY_POS);
       if(OrderType()==OP_BUY){
          chk=OrderClose(OrderTicket(),OrderLots(),Bid,0,White);
       }   
       if(OrderType()==OP_SELL){   
          chk=OrderClose(OrderTicket(),OrderLots(),Ask,0,White);
       }
    }
 }

 
   eqt=AccountEquity()*100;
   eqt=int(eqt);
   eqt=eqt/100;
   
   bal=AccountBalance()*100;
   bal=int(bal);
   bal=bal/100;
   
   x=tpopen-Hedge;
   tp1=Lot*HedgeF;
   
   Comment("\n\n                       Balance: ",bal,
   "\n                       Equity: " ,eqt,
   "\n                       Lot: ",Lot,
   "\n                       Leverage: 1:",AccountLeverage(),
   "\n                       Hedge Price: ",x,
   "\n                       Hedge Lot: ",tp1);
   
   
 }
